Controllers/EnrollmentController.cs
using Microsoft.AspNetCore.Mvc;
using CoursesSec001.Models;
using CoursesSec001.Models.DataModels;

using CoursesSec001.Data;
using System.Collections.Generic;
using System.Linq;
using Microsoft.AspNetCore.Http;
using Microsoft.EntityFrameworkCore;

namespace CoursesSec001.Controllers
{
    public class EnrollmentController : Controller
    {
        private readonly CoursesContext _context;

        public EnrollmentController(CoursesContext context)
        {
            _context = context;
        }

        public IActionResult Index()
        {
            List<Enrollment> enrollments = _context.Enrollments
                                                    .Include(e=> e.Course)
                                                    .Include(e => e.Student)
                                                    .ToList();

            EnrollmentsIndexDataModel model = new EnrollmentsIndexDataModel();

            model.Enrollments = enrollments;

            return View(model);
        }

        public IActionResult Create(int studentId)
        {
            Student student = _context.Students.FirstOrDefault(s => s.ID == studentId);

            if (student == null)
			{
                return NotFound();
			}

            List<Course> courses = _context.Courses.ToList();

            Enrollment enrollment = new Enrollment();
            enrollment.StudentID = student.ID;

            EnrollmentsCreateDataModel model = new EnrollmentsCreateDataModel();

            model.Student = student;
            model.Courses = courses;
            model.Enrollment = enrollment;

            return View(model);
        }

        [HttpPost]
        public IActionResult Create(IFormCollection formCollection)
        {
			if (ModelState.IsValid)
			{
                int studentId = int.Parse(formCollection["Enrollment.StudentID"]);
                string courseTitle = formCollection["Enrollment.CourseID"];

                Course course = _context.Courses.FirstOrDefault(c => c.Title.Equals(courseTitle));



                if (course == null) return NotFound();

                Enrollment newEnrollment = new Enrollment();

                bool exists = _context.Enrollments.Where(s => s.CourseID == course.ID && s.StudentID == studentId).Count() > 0 ? true : false;

                /*
                if(_context.Enrollments.Where(s => s.CourseID == course.ID && s.StudentID == studentId).Count() > 0)
				{
                    exists = true;
                } else
				{
                    exists = false;
				}
                */

                /*
                List<Enrollment> enrollments = _context.Enrollments.ToList();
                foreach(var enrollment in enrollments)
				{
                    if(enrollment.StudentID == studentId && enrollment.CourseID == course.ID)
					{
                        exists = true;
					}
				}*/

                if (exists)
				{
                    return BadRequest();
				}

                newEnrollment.StudentID = studentId;
                newEnrollment.CourseID = course.ID;

                _context.Enrollments.Add(newEnrollment);
                _context.SaveChanges();
			}

            return RedirectToAction(nameof(Index));
        }
    }
}

Controllers/StudentController.cs
using Microsoft.AspNetCore.Mvc;
using CoursesSec001.Data;

using System.Collections.Generic;
using System.Linq;

using CoursesSec001.Models;
using CoursesSec001.Models.DataModels;


namespace CoursesSec001.Controllers
{
    public class StudentController : Controller
    {
        private readonly CoursesContext _context;

        public StudentController(CoursesContext context)
        {
            this._context = context;
        }
       
        public IActionResult Index()
        {
            //obtener todos los estudiantes
            //var students = _context.Students.ToList();
            List<Student> students = _context.Students.ToList();

            //obtienes los estudiantes que tengan el nombre juan
            /*var studentss = from student in _context.Students
                            where student.FirstName.Equals("Juan")
                            select new { student.FirstName, student.LastName };

            List<Student> students_context.Students.Where(s => s.FirstName.Equals("Juan"))
                .Select(s => s.FirstName).ToList();*/

            StudentIndexDataModel studentIndexDataModel = new StudentIndexDataModel();
            studentIndexDataModel.Students = students;

            return View(studentIndexDataModel);
        }

        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Create(Student student)
        {
            if(ModelState.IsValid)
            {
                student.EnrollmentDate = System.DateTime.Now;
                _context.Students.Add(student);
                _context.SaveChanges();   
            }
            return RedirectToAction(nameof(Index));
        }
    
        public IActionResult Edit(int studentId)
		{
            Student student = _context.Students.FirstOrDefault(s => s.ID == studentId);

            if (student == null) return NotFound();

            return View(student);
		}

		[HttpPost]
        public IActionResult Edit(Student student)
		{
			if (ModelState.IsValid)
			{
                _context.Students.Update(student);
                _context.SaveChanges();
                return RedirectToAction(nameof(Index));
            }

            return View(student);
		}
    }
}

Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - CoursesSec001</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.0/css/all.css" integrity="sha384-lZN37f5QGtY3VHgisS14W3ExzMWZxybE1SJSEsQp9S+oqd12jhcu+A56Ebc1zFSJ" crossorigin="anonymous">
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">CoursesSec001</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Student" asp-action="Index">Estudiantes</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Enrollment" asp-action="Index">Enrolamientos</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2022 - CoursesSec001 - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>